/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*- */

#ifndef GENERAL__SHARED_PTR_HH
#define GENERAL__SHARED_PTR_HH
   
#include <tr1/memory>

namespace General
{
  using std::tr1::shared_ptr;

  template< class T>
  class SharedPtr
    : public shared_ptr< T >
  {
  public:
    inline SharedPtr( )
    {
    }

    inline SharedPtr( T* Ptr )
      : shared_ptr< T >( Ptr )
    {
    }

    inline SharedPtr( SharedPtr< T > const & Ptr )
      : shared_ptr< T >( Ptr )
    {
    }

    inline SharedPtr( shared_ptr< T > const & Ptr )
      : shared_ptr< T >( Ptr )
    {
    }
  };
  
  template< class T>
  class SharedConstPtr
    : public SharedPtr< T >
  {
  public:
    inline SharedConstPtr( )
    {
    }

    inline SharedConstPtr( T* Ptr )
      : SharedPtr< T >( Ptr )
    {
    }

    inline SharedConstPtr( SharedPtr< T > const & Ptr )
      : SharedPtr< T >( Ptr )
    {
    }

    inline SharedConstPtr( shared_ptr< T > const & Ptr )
      : SharedPtr< T >( Ptr )
    {
    }

    inline
    const T& operator*( ) const
    {
      return SharedPtr< T >::operator*( );
    }

    inline
    const T* operator->( ) const
    {
      return SharedPtr< T >::operator->( );
    }

    inline
    const T* get( ) const
    {
      return SharedPtr< T >::get( );
    }
  };
  
  using std::tr1::weak_ptr;

  template< class T>
  class WeakPtr
    : public weak_ptr< T >
  {
  public:
    inline WeakPtr( )
    {
    }

    inline WeakPtr( SharedPtr< T > Ptr )
      : weak_ptr< T >( Ptr )
    {
    }
  };
  
}

#endif /* GENERAL__SHARED_PTR_HH */
